/*
compile with

gcc gtktextview.c -o gtktextview `pkg-config --cflags --libs gtk+-2.0`
*/

#include <gtk/gtk.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <fcntl.h>


GtkWidget *window, *scroll, *view, *button, *hbox, *vbox, *buttonbox, *entrybox, *entry, *loadfilebutton, *clearfilebutton;
GtkTextBuffer *buffer;

/* Another callback */
static void destroy( GtkWidget *widget,
                     gpointer   data )
{
    gtk_main_quit ();
}

static gboolean delete_event( GtkWidget *widget,
                              GdkEvent  *event,
                              gpointer   data )
{
    return FALSE;
} 


void loadfile_callback(GtkWidget *button)
{
    GtkTextIter *end_iter;
	char *filename, buf[1024];
	int fd, i; 
	filename = (char*)gtk_entry_get_text(GTK_ENTRY(entry));

    if ( access(filename, R_OK) )
    	return;
    	
	fd=open(filename,O_RDONLY );
	while ( (i=read(fd, buf, 1024)) > 0) {
		gtk_text_buffer_insert_at_cursor (buffer, buf, i);    	
	}

	
}

void clear_callback(GtkWidget *button)
{
    gtk_text_buffer_set_text (buffer, "", -1);
}

void reload_gtkrc_callback(GtkWidget *button, GtkWidget *view)
{
    gtk_rc_reparse_all();
    
}

int main( int   argc, char *argv[] )
{
 
    gtk_init (&argc, &argv);
            
    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    g_signal_connect (G_OBJECT (window), "delete_event", G_CALLBACK (delete_event), NULL);
    g_signal_connect (G_OBJECT (window), "destroy", G_CALLBACK (destroy), NULL);
    gtk_widget_set_size_request (window, 640, 480);

    view = gtk_text_view_new ();
    buffer = gtk_text_view_get_buffer (GTK_TEXT_VIEW (view));
    gtk_text_buffer_set_text (buffer, "You can type some text inside this GTKTextView or load text from a file", -1);
    scroll = gtk_scrolled_window_new(NULL, NULL);
	gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW (scroll), view);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW (scroll), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);


	buttonbox = gtk_hbox_new (TRUE, 5);
	button = gtk_button_new_with_label("Reload gtkrc");
    g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (reload_gtkrc_callback), G_OBJECT (window));
    gtk_box_pack_start(GTK_BOX(buttonbox), button, TRUE, TRUE, 5); 
   	button = gtk_button_new_with_label("Quit");
    g_signal_connect_swapped (G_OBJECT (button), "clicked", G_CALLBACK (gtk_widget_destroy), G_OBJECT (view));
    gtk_box_pack_start(GTK_BOX(buttonbox), button, TRUE, TRUE, 5); 

	entrybox = gtk_hbox_new (FALSE, 5);
    entry = gtk_entry_new ();
    gtk_entry_set_text (GTK_ENTRY(entry), "Enter here name of file to be displayed");
    gtk_entry_set_max_length (GTK_ENTRY (entry), 256 );
   	loadfilebutton = gtk_button_new_with_label("Append file");
    g_signal_connect (G_OBJECT (loadfilebutton), "clicked", G_CALLBACK (loadfile_callback), NULL);
	clearfilebutton = gtk_button_new_with_label("Clear");
    g_signal_connect (G_OBJECT (clearfilebutton), "clicked", G_CALLBACK (clear_callback), NULL);
    gtk_box_pack_start(GTK_BOX(entrybox), entry, TRUE, TRUE, 5); 
    gtk_box_pack_start(GTK_BOX(entrybox), loadfilebutton, FALSE, TRUE, 5); 
    gtk_box_pack_start(GTK_BOX(entrybox), clearfilebutton, FALSE, TRUE, 5);

    vbox = gtk_vbox_new (FALSE, 5);
    gtk_box_pack_start(GTK_BOX(vbox), scroll, TRUE, TRUE, 5);
    gtk_box_pack_start(GTK_BOX(vbox), entrybox, FALSE, TRUE, 5);
    gtk_box_pack_start(GTK_BOX(vbox), buttonbox, FALSE, TRUE, 5);
    hbox = gtk_hbox_new (FALSE, 5);
    gtk_box_pack_start(GTK_BOX(hbox), vbox, TRUE, TRUE, 5);
    
    gtk_container_add(GTK_CONTAINER(window), hbox);

    gtk_widget_show_all (window);

    gtk_main ();
    
    return 0;
}
